int s_x(int x);
int s_y(int y);
int m_x(int x);
int m_y(int y);
int difference(int v1, int v2);
double distance(int x1, int y1, int x2, int y2);
double distance_to_line(int x1, int y1, int x2, int y2, int vx, int vy);
void draw_2d_screen();
void get_hilight_item();
void select_item();
void select_items_box();
void clear_selection();
bool selection();
int snap_to_grid(int pos);
int snap_to_grid_custom(int pos);
point2_t midpoint(point2_t p1, point2_t p2);
int get_side_sector(int line, int side);
void move_items();
void add_move_items();
void clear_move_items();
int check_vertex_split(DWORD vertex);
int check_vertex_split(point2_t p);
void create_vertex();
void create_thing();
void create_lines(bool close);
void create_sector();
void delete_vertex();
void delete_line();
void delete_thing();
void delete_sector();
void init_map();
int determine_sector(int x, int y);
void update_grid();
void update_map();
void line_flip(bool verts, bool sides);
void sector_changeheight(bool floor, int amount);
void line_drawpoint();
void end_linedraw();
void line_undrawpoint();
int get_nearest_line_2(int x, int y);
bool determine_line_side(int line, float x, float y);
bool determine_line_side(rect_t r, float x, float y);
bool determine_line_side(float x1, float y1, float x2, float y2, float x, float y);
float determine_line_side_f(rect_t r, float x, float y);
void map_changelevel(int level);
void thing_setquickangle();
void merge_verts();
bool check_gui_mouse();

struct movelist_t
{
	DWORD		n_items;
	DWORD		*items;
	point2_t	*offsets;
	point2_t	cursor_offset;
	bool		cursor_snap;

	movelist_t()
	{
		items = NULL;
		offsets = NULL;
		cursor_snap = false;
		n_items = 0;
	}

	void add(point2_t p, DWORD t)
	{
		n_items++;
		items = (DWORD *)realloc(items, n_items * sizeof(DWORD));
		offsets = (point2_t *)realloc(offsets, n_items * sizeof(point2_t));
		items[n_items - 1] = t;
		offsets[n_items - 1].set(p);
	}

	void clear()
	{
		free(items);
		free(offsets);
		items = NULL;
		offsets = NULL;
		n_items = 0;
		cursor_snap = false;
		cursor_offset.set(0, 0);
	}

	int get_x(DWORD item, int pos)
	{
		DWORD i = 0;
		for (i = 0; i < n_items; i++)
		{
			if (items[i] == item)
				break;
		}

		if (cursor_snap)
			return snap_to_grid(pos) + cursor_offset.x + offsets[i].x;
		else
			return snap_to_grid(pos + offsets[i].x);
	}

	int get_y(DWORD item, int pos)
	{
		DWORD i = 0;

		for (i = 0; i < n_items; i++)
		{
			if (items[i] == item)
				break;
		}

		if (cursor_snap)
			return snap_to_grid(pos) + cursor_offset.y + offsets[i].y;
		else
			return snap_to_grid(pos + offsets[i].y);
	}

	bool exists(DWORD item)
	{
		for (DWORD i = 0; i < n_items; i++)
		{
			if (items[i] == item)
				return true;
		}

		return false;
	}
};
